import opale.tools.*;
import opale.mathtools.*;
import opale.ode.*;
import opale.ode.scheme.*;
import opale.m2d.*;
import opale.m2d.object2d.*;
import opale.m2d.component2d.*;


public class Control
	{
	
	public static void main(String[] arg)
	{
	Problem pb = new Problem(1);	//problme en dimension 1
	ExplicitEuler ts = new ExplicitEuler();		
	StepControl1 contr = new StepControl1(0,10,1.1);
	ts.setStepsizeControl(contr);
	
	DVect cd = new DVect(1);	// vecteur pour la condition initiale
	
	ts.setNstep(3);		//nombre de pas en temps 
	ts.set(0,10);			// tude sur l'intervalle en temps (0;1)
	pb.setEqn(			//on dfinit l'equation du systme 
		new Equation()
			{
			DVect y = new DVect(1);
			public int dim() { return 1; }
			public DVect derivs(double t, DVect x)
				{
				y.set(0,-x.get(0));		//x'(t,x,y,z,w) = z		
			return y;
				}
			}
		);

	pb.setTS(ts);	//on associe le schma en temps
	// on rsoud les quations de la dynamique
	cd.set(0,1);
	pb.setInit(cd);
	pb.solve();
	double[][] sol=pb.toArray();
	
	System.out.println(pb.printSol());
	
	
	// On affiche le rsultat avec le module 2d d'Opale
	JFrame2D jf = new JFrame2D(true);
	jf.setSize(600,600);
	jf.getAxis().drawScale(false);
	OIJ repere = new OIJ();
	jf.getCS().set(-1,2,-1,1);
	jf.getPack2D().add(repere,"repere");
	GData2D gsol = new GData2D(repere);
	//chaque solution est reprsente par un objet de type GData2D (nuage de points)
	
	
		gsol.set(pb.getNStep(),sol[0],sol[1]);
		jf.getPack2D().add(gsol,"sol");
	jf.show();
	
	
	
	}

}
