@echo off

REM Creates an archive opale.jar with all modules.

if "%OPALE_DIR%" == "" goto error

if "%OJC%" == "" goto error2




echo "---------------------------------------------------------------"
echo "Creates opale.jar in the directory %OPALE_DIR%arch"
echo "---------------------------------------------------------------"


md %OPALE_DIR%arch

REM building opale\tools
echo "building opale.tools..."
%OJC% -nowarn -deprecation -d %OPALE_DIR%arch %OPALE_DIR%opale\tools\*.java

REM opale/cst
echo "building opale.cst..."
%OJC% -nowarn -deprecation -d %OPALE_DIR%arch %OPALE_DIR%opale\cst\*.java
%OJC% -nowarn -deprecation -d %OPALE_DIR%arch %OPALE_DIR%opale\cst\chemistry\*.java


REM building de opale\swools
echo "building opale.swools..."
%OJC% -nowarn -deprecation -d %OPALE_DIR%arch %OPALE_DIR%opale\swools\*.java


REM building de opale\mathtools
echo "building opale.mathtools..."
%OJC% -nowarn -deprecation -d %OPALE_DIR%arch %OPALE_DIR%opale\mathtools\*.java



REM building opale\ode
echo " building opale\ode "
%OJC% -nowarn -deprecation -d %OPALE_DIR%arch %OPALE_DIR%opale\ode\*.java
%OJC% -nowarn -deprecation -d %OPALE_DIR%arch %OPALE_DIR%opale\ode\scheme\*.java
copy %OPALE_DIR%opale\ode\name.rsc %OPALE_DIR%arch\opale\ode


REM building  opale\matrix
echo "building de opale\matrix"
%OJC% -nowarn -deprecation -d %OPALE_DIR%arch %OPALE_DIR%opale\matrix\*.java
%OJC% -nowarn -deprecation -d %OPALE_DIR%arch %OPALE_DIR%opale\matrix\solver\*.java



REM building de opale\m2d
echo "building opale.m2d..."
%OJC% -nowarn -deprecation -d %OPALE_DIR%arch %OPALE_DIR%opale\m2d\*.java
%OJC% -nowarn -deprecation -d %OPALE_DIR%arch %OPALE_DIR%opale\m2d\object\*.java
%OJC% -nowarn -deprecation -d %OPALE_DIR%arch %OPALE_DIR%opale\m2d\component\*.java

copy %OPALE_DIR%opale\m2d\list_object.cfg %OPALE_DIR%arch\opale\m2d

echo ""
echo "Building opale.jar..."
cd %OPALE_DIR%arch
jar cfm opale.jar %OPALE_DIR%utils\sh\Manifest opale


goto fin

:error
echo variable OPALE_DIR not set !
echo Please set the OPALE_DIR variable !
echo aborting
 
:error2
echo variable OJC not set !
echo Please set the OJC variable !
echo The OJC variable is your Opale Java Compiler 
echo which must be define to compile Opale
echo aborting

:fin


echo Script finished